import 'package:osam/domain/state/base_state.dart';

// ignore: must_be_immutable
class NavigationState<T> extends BaseState<NavigationState<T>> {
  var routes = <T>[];

  void push(T route) => routes.add(route);

  void pushReplacement(T route) => routes..replaceRange(routes.length - 1, routes.length, [route]);

  void pop() => routes.removeLast();

  @override
  List<T> get props => [...routes];
}

// ignore: must_be_immutable
class TabNavigatorState<T> extends BaseState<TabNavigatorState> {
  T currentTab;

  @override
  List<T> get props => [currentTab];
}
