import 'package:osam/domain/state/base_state.dart';
import 'package:osam/domain/store/store.dart';
import 'package:osam/navigation/domain/navigation_state.dart';
import 'package:osam/presentation/presenter.dart';
import 'package:osam/util/state_stream.dart';

import 'navigation_presenter_interface.dart';

abstract class NavigationPresenter<S extends Store<BaseState>, T> extends Presenter<S>
    implements INavigation<T> {
  NavigationState<T> get state;

  @override
  void pop() => state.pop();

  @override
  void push(route) => state.push(route);

  @override
  void pushReplacement(route);

  @override
  StateStream<List<T>> get routeStream => state.propertyStream((state) => state.routes);
}
